#ifndef	EXECKICK_H
#define	EXECKICK_H

#define __NOLIBBASE__
#define SysBase (*(struct ExecBase **)4)

#include "exec/resident.h"
#include "exec/nodes.h"
#include "exec/execbase.h"
#include "proto/exec.h"

#ifndef NULL
#define NULL ((void *)0)
#endif

#define TOSTR(x) #x

#ifdef COFF
#define KTATTR
#define KTCONST
#define KTEND (struct Resident *)&coffdataend
extern KTCONST char coffdataend;
#define EXECKICK_END static KTCONST char coffdataend=0x66;
#define DOTINLINE
#else
#define KTCONST const
#define KTATTR __attribute__ ((section ("KickTags")))
#define KTEND (struct Resident *)(&restag)+1
#define EXECKICK_END
#define DOTINLINE inline
#endif

#define KICKTAG(func,name,id,pri) \
static void func (void); \
static KTCONST struct Resident restag KTATTR = { \
  RTC_MATCHWORD, \
	(struct Resident *)&restag, KTEND, \
	RTF_COLDSTART,40,NT_UNKNOWN,pri, \
	(char *)name,(char *)name " " id "\r\n", \
	func}

#define next_arg(arg) ((APTR)(&(arg)+1))

static DOTINLINE void printd(const char *fmt,...)
{
	RawDoFmt((unsigned char *)fmt,next_arg(fmt),RawPutCharFunc,NULL);
}

static inline void printdnl(void)
{ RawPutChar('\n'); }

#define NEWLIST(this,type) \
  { (struct Node *)&(this)->lh_Tail,NULL,(struct Node *)(this),(type),0 }

static inline void NewList(struct List *list)
{
	list->lh_Head=(struct Node *)&list->lh_Tail;
	list->lh_Tail=NULL;
	list->lh_TailPred=(struct Node *)list;
}

static void _sprintf_writea3(void)
{
__asm volatile ("moveb d0,a3@+" : /* out */ : /* in */ : "cc", "memory");
}

static DOTINLINE sprintf(char *buffer,const char *fmt,...)
{
	RawDoFmt((UBYTE *)fmt,next_arg(fmt),_sprintf_writea3,buffer);
}

static void BeginIO(struct IORequest *ioreq)
{ register struct IORequest *a1 asm("a1")=ioreq;
  register struct Device    *a6 asm("a6")=ioreq->io_Device;
  __asm volatile ("jsr -" TOSTR(DEV_BEGINIO) "(a6)" : /* out */ : /* in */ "r"(a1),"r"(a6)
      : "d0", "d1", "a0", "a1", "fp0", "fp1", "cc", "memory");
}

#include "ixemul.c"

#endif	/* EXECKICK_H */
