#ifndef _IXEMUL_H_
#define _IXEMUL_H_

#include <exec/memory.h>

typedef unsigned long u_long;
typedef unsigned int  u_int ;

#define kmalloc(size) AllocVec((size),MEMF_PUBLIC)
#define kfree(mem) FreeVec((mem))

  /* because we added a MemList structure to the task's tc_MemEntry
   * structure, all the memory will be freed up for us! */
#define DeleteTask RemTask

#define CreateStdIO(replyport) ((struct IOStdReq *)CreateExtIO(replyport,sizeof(struct IOStdReq)))
#define DeleteStdIO(ios) DeleteExtIO(ios)

#endif /* _IXEMUL_H */
