	.include	"incl.i.as"

SysBase	equ	4

	.ifdef	COFF

	.macro	section_a,name
	.section	\name
	.endm
	.macro	section_ax,name
	.section	\name
	.endm

	.else

	.macro	section_a,name
	.section	\name,"a"
	.endm
	.macro	section_ax,name
	.section	\name,"ax"
	.endm

	.endif

	.macro	KICKTAG,func,name,id,pri
	section_a	KickTags
	.even
Resident\@	dc.w	RTC_MATCHWORD	;Matchword
	dc.l	Resident\@	;MatchTag
	dc.l	ResidentEnd\@	;Endskip
	dc.b	RTF_COLDSTART	;Flags
	dc.b	40	;Version
	dc.b	NT_UNKNOWN	;Type
	dc.b	\pri	;Pri (-55 is AlertHook)
	dc.l	ResidentName\@	;Name
	dc.l	ResidentID\@	;Idstring
	dc.l	\func	;Init
ResidentEnd\@

	section_a	.rodata
ResidentName\@
	.string	"\name"
ResidentID\@
	.ascii	"\name"
	dc.b	' '
	.ascii	"\id"
	dc.b	$D,$A,0

	section_ax	.text
	.endm

	.macro	labstr,str,label
	section_a	.rodata
\label	.string	"\str"
	section_ax	.text
	.endm

	.macro	regstr,str,reg
	section_a	.rodata
String\@	.string	"\str"
	section_ax	.text
	lea	String\@,\reg
	.endm

	.macro	printd,fmt,regs=NOTDEF
	.ifeqs	"\regs","NOTDEF"
	.else
	movem.l	\regs,-(sp)
	move.l	sp,a1
	.endif
	regstr	"\fmt",a0
	move.l	SysBase,a6
	move.l	a2,-(sp)
	lea	_LVORawPutChar(a6),a2
	jsr	_LVORawDoFmt(a6)
	move.l	(sp)+,a2
	.ifeqs	"\regs","NOTDEF"
	.else
	movem.l	(sp)+,\regs
	.endif
	.endm
